est.tpm <- function(states,K,mixture=FALSE) {
#
# Function est.tpm to estimate the
# transition probability matrix of a hidden Markov model, given the
# catenated sequences of states from the cells of the model
# separated by -1's.
#

states<-states[!is.na(states)]
n  <- length(states)
tpm <- matrix(.Fortran(
		'esttpm',
		ns=as.integer(states),
		n=as.integer(n),
		k=as.integer(K),
		tpm=double(K*K),
		mixture=as.integer(mixture),
		wrk=double(K),
		PACKAGE="hglmm"
		)$tpm,nrow=K)
tpm[tpm < 0.001] <- 0.001
tpm/apply(tpm,1,sum)
}
