fitted.hglmm <- function(object,...) {
	fy      <- object$fy
	tpm     <- object$params$tpm
	cf      <- object$data$cf
	epsilon <- .Machine$double.eps
	gamma   <- recurse(fy,tpm,cf,epsilon,mixture=FALSE)$gamma
	lambda  <- tapply(object$lambda,object$data$state,function(x){x})
	lambda  <- do.call("cbind",lambda)
	yhat    <- apply(t(gamma)*lambda,1,sum)
	data    <- object$data
	data    <- data[data$state==levels(data$state)[1],]
        jjj     <- match(c("cf","state"),names(data))
	data    <- data[,-jjj]
	attr(yhat,"data") <- data
	class(yhat) <- "fitted.hglmm"
	yhat
}
