get.l <- function(theta,K,X,y,cf) {
#
# Function get.l --- get log likelihood.
#
npar <- length(theta)
npro <- K*(K-1)
nphi <- npar-npro
rho  <- theta[1:npro]
tpm  <- fix.tpm(rho,K,TRUE)
ispd <- revise.ispd(tpm)
phi  <- theta[-(1:npro)]
lam  <- exp(X%*%phi)
fy   <- dpois(y,lam)
fy[is.na(fy)] <- 1
ncf  <- table(cf)
nc   <- length(ncf)
lcf  <- as.character(cf[cumsum(ncf)])

# Run through the cells:
alist  <- list()
xllist <- list()
filist <- list()
for(xl in lcf) {
	ind   <- (cf==xl)
	fyxl  <- matrix(fy[ind],nrow=K)
	lamxl <- matrix(lam[ind],nrow=K)
	yxl   <- matrix(y[ind],ncol=K,byrow=TRUE)[,1] # All columns identical.
	ny    <- length(yxl)

	xxx   <- .Fortran(
		"getl",
		fy=as.double(fyxl),
		xlam=as.double(lamxl),
		tpm=as.double(tpm),
		xispd=as.double(ispd),
		kstate=as.integer(K),
		n=as.integer(ny),
		alpha=double(K),
		alphw=double(K),
		xlc=double(ny),
		PACKAGE="hglmm"
		)
	xlc <- xxx$xlc
	xllist[[xl]] <- sum(log(xlc))
} 
sum(unlist(xllist))
}
