lmstep <- function(theta,K,X,y,cf,lmc) {
#
# Function lmstep to do one Levenberg-Marquardt step.
#
xxx     <- get.hgl(theta,K,X,y,cf)
hess    <- xxx$hess
ev      <- eigen(hess)$values
osag    <- sum(abs(xxx$grad))
npar    <- length(theta)
old.ll  <- xxx$ll
steepit <- FALSE
repeat {
	lll       <- lmc + max(0,ev)
	hess.mod  <- hess - lll*diag(npar)
	theta.new <- theta - solve(hess.mod)%*%xxx$grad
	yyy       <- try(get.gl(theta.new,K,X,y,cf),TRUE)
	if(class(yyy)=="try-error") {
		steepit <- TRUE
		break
	}
	new.ll    <- yyy$ll
        nsag      <- sum(abs(yyy$grad))
        if(all(is.finite(c(old.ll,new.ll,osag,nsag))) &&
                (new.ll > old.ll & nsag < osag)) break
	lmc <- 10*lmc
        if(1/lmc < sqrt(.Machine$double.eps)) {
		steepit <- TRUE
		break
	}
}
if(steepit) {
	theta.new <- steepest(K,X,y,cf,theta)
	yyy <- get.gl(theta.new, K, X, y, cf)
	lmc <- 1
}
list(theta=theta.new,ll=yyy$ll,grad=yyy$grad,lmc=lmc)
}
