revise.model <- function(formula,data,overpar=FALSE) {
#
# Function revise.model.  Calculates updated value of the
# model parameters, given a data frame which includes
# weights (== the gamma's) for each state, at each time.
#
rslt <- glm(formula, data=data, weights=weights, family=poisson,
            na.action=na.omit)

phi <- coef(rslt)
nms <- names(phi)
nms[nms=='(Intercept)'] <- 'mu'
names(phi) <- nms

if(overpar) {
	dc <- dummy.coef(rslt)
	nms <- names(dc)
	nms[nms=='(Intercept)'] <- 'mu'
	names(dc) <- nms
} else dc <- NULL

lam  <- predict(rslt,newdata=data,type="response")
ynm  <- as.character(formula)[2]
fy   <- dpois(data[,ynm],lam)
fy[is.na(fy)] <- 1
list(phi=phi,phi.over=dc,lambda=lam,fy=fy)
}
