rhglmm.hglmm <-function(object,miss.frac=NULL,set.con=TRUE,...) {
#
# Function rhglmm (r for random) to simulate data from a hidden
# generalized linear Markov model.
#

# Keep the kontrasts konsistent. (Note that sim.mlt() uses
# the contrasts in forming the model matrix.)
# If rhglmm() is called by bcov(), set.con will be set to FALSE,
# because the setting of the contrasts will already have been done.
if(set.con) {
	contr  <- unname(unlist(object$contrasts))
	oldc   <- options(contrasts=contr)
	on.exit(options(oldc))
}

ispd <- object$params$ispd
tpm  <- object$params$tpm
phi  <- object$params$phi
fmla <- object$formula
data <- object$data

if(is.null(miss.frac)) miss.frac <- object$miss.frac

sim.mlt(fmla,data,ispd,tpm,phi,miss.frac)
}
