sim.mlt <- function(formula,data,ispd,tpm,phi,miss.frac=0)
{
# Function sim.mlt.  Simulates data from all cells, in turn
# of a Hidden Markov Model.

cf    <- data$cf
ncf   <- table(cf)
lcf   <- as.character(cf[cumsum(ncf)])

rslt <- list()
for(xl in lcf) {
	X   <- model.matrix(formula[-2],data[cf==xl,])
	blp <- X%*%phi
	rslt[[xl]] <- sim.sngl(blp,ispd,tpm,miss.frac)
}
y     <- unlist(rslt)
K     <- length(ispd)
n     <- nrow(data)
ind   <- K*(1:(n/K))
ynm   <- as.character(formula)[2]
norep <- data[ind,]
norep[["state"]] <- NULL
norep[["cf"]]    <- NULL
norep[[ynm]]     <- y
row.names(norep) <- 1:nrow(norep)
norep
}
