sim.sngl <- function(blp,ispd,tpm,mf)
{
# Function sim.sngl.  Simulates data from a single cell of a hidden
# Markov model.  Meaning of arguments:
# blp   <--> base linear predictor.
# state <--> vector of parameters, one for each state of the chain.
# ispd  <--> initial state probability distribution.
# tpm   <--> transition probability matrix.
# mf    <--> fraction of missing values.
#
	lambda      <- list()
	K           <- length(ispd)
	s1          <- sample(1:K,1,prob=ispd)
	lambda[[1]] <- exp(blp[s1])
	nt <- length(blp)/K
	for(t in 2:nt) {
		s1 <- sample(1:K,1,prob=tpm[s1,])
		k1 <- K*(t-1) + s1
		lambda[[t]] <- exp(blp[k1])
	}
	lambda <- unlist(lambda)
	y <- rpois(nt,lambda)
	temp <- runif(nt)<mf
	y[temp] <- NA
	y
}
