# $Id: gethgl.r,v 1.3 2016/03/15 06:06:09 rolf Exp rolf $
subroutine gethgl(fy,xlam,y,ymiss,dmat,nind,tpm,xispd,d1pi,d2pi,kstate,n,
                  nphi,npar,d1p,d2p,d1f,d2f,alpha,alphw,a,b,aw,bw,xlc,hess)
implicit double precision(a-h,o-z)

integer   ymiss(n)
dimension fy(kstate,n), xlam(kstate,n), y(n), dmat(nphi,nind)
dimension tpm(kstate,kstate), xispd(kstate)
dimension d1pi(kstate,npar), d2pi(kstate,npar,npar)
dimension d1p(kstate,kstate,npar), d2p(kstate,kstate,npar,npar)
dimension d1f(kstate,npar), d2f(kstate,npar,npar)
dimension alpha(kstate), alphw(kstate)
dimension a(kstate,npar), b(kstate,npar,npar)
dimension aw(kstate,npar), bw(kstate,npar,npar)
dimension xlc(n), hess(npar,npar)

# Set zero.
zero = 0.d0

# Initialize; i.e. do the t = 1 case:
call deriv1f(fy(1,1),xlam(1,1),y(1),ymiss(1),dmat(1,1),nind,kstate,npar,nphi,d1f)
call deriv2f(fy(1,1),xlam(1,1),y(1),ymiss(1),dmat(1,1),kstate,npar,nphi,d1f,d2f)
sxlc = zero
do j = 1,kstate {
	alpha(j) = xispd(j)*fy(j,1)
	sxlc = sxlc + alpha(j)
	do k1 = 1,npar {
		a(j,k1) = xispd(j)*d1f(j,k1) + fy(j,1)*d1pi(j,k1)
		do k2 = 1,npar {
			b(j,k1,k2) = (xispd(j)*d2f(j,k1,k2) +
                                      d1pi(j,k1)*d1f(j,k2) +
                                      d1f(j,k1)*d1pi(j,k2) +
                                      fy(j,1)*d2pi(j,k1,k2))
		}
	}
}
xlc(1) = sxlc

do j = 1,kstate {
	alpha(j) = alpha(j)/sxlc
}

if(n>1) {
do kt = 2,n {
	kstart = 1+(kt-1)*kstate
	call deriv1f(fy(1,kt),xlam(1,kt),y(kt),ymiss(kt),dmat(1,kstart),
                     nind,kstate,npar,nphi,d1f)
	call deriv2f(fy(1,kt),xlam(1,kt),y(kt),ymiss(kt),dmat(1,kstart),
                     kstate,npar,nphi,d1f,d2f)
# Do the b's:
	do j = 1,kstate {
		do k1 = 1,npar {
			do k2 = 1,npar {
				vvv = zero
				xxx = zero
				yy1 = zero
				yy2 = zero
				zz1 = zero
				zz2 = zero
				www = zero
				do i = 1,kstate {
					vvv = vvv + alpha(i)*d2p(i,j,k1,k2)
					xxx = (xxx + a(i,k1)*d1p(i,j,k2) +
                                                     a(i,k2)*d1p(i,j,k1) +
                                                     b(i,k1,k2)*tpm(i,j))
                                        yy1 = yy1 + alpha(i)*d1p(i,j,k2)
					yy2 = yy2 + a(i,k2)*tpm(i,j)
                                        zz1 = zz1 + alpha(i)*d1p(i,j,k1)
					zz2 = zz2 + a(i,k1)*tpm(i,j)
                                        www = www + alpha(i)*tpm(i,j)
				}
				vvv = fy(j,kt)*vvv
				xxx = fy(j,kt)*xxx/sxlc
				yyy = d1f(j,k1)*(yy1 + yy2/sxlc)
				zzz = d1f(j,k2)*(zz1 + zz2/sxlc)
				www = d2f(j,k1,k2)*www
				bw(j,k1,k2) = xxx + yyy + zzz + www
			}
		}
	}
	do j = 1,kstate {
		do k1 = 1,npar {
			do k2 = 1,npar {
				b(j,k1,k2) = bw(j,k1,k2)
			}
		}
	}

# Do the a's:
	do j = 1,kstate {
		do k = 1,npar {
			xxx = zero
			yyy = zero
			zzz = zero
			do i = 1, kstate {
				xxx = xxx + alpha(i)*d1p(i,j,k)
				yyy = yyy + a(i,k)*tpm(i,j)
				zzz = zzz + alpha(i)*tpm(i,j)
			}
			aw(j,k) = fy(j,kt)*(xxx + yyy/sxlc) + d1f(j,k)*zzz
		}
	}
	do j = 1,kstate {
		do k = 1,npar {
			a(j,k) = aw(j,k)
		}
	}

# Do the alpha's:
	sxlc = zero
	do j = 1,kstate {
		alphw(j) = zero
		do i = 1,kstate {
			alphw(j) = alphw(j) + alpha(i)*tpm(i,j)
		}
		alphw(j) = fy(j,kt)*alphw(j)
		sxlc = sxlc + alphw(j)
	}
	xlc(kt) = sxlc
	do j = 1,kstate {
		alpha(j) = alphw(j)/sxlc
	}
}
}

# Finish off:
do k1 = 1,npar {
	do k2 = 1,npar {
		xxx = zero
		yyy = zero
		zzz = zero
		do i = 1,kstate {
			xxx = xxx + b(i,k1,k2)
			yyy = yyy + a(i,k1)
			zzz = zzz + a(i,k2)
		}
		hess(k1,k2) = (xxx - yyy*zzz/sxlc)/sxlc
	}
}

return
end
